<?php

include_once("class.bocalendar.inc.php");

class uicalendar
{
	function uicalendar() {
		$this -> daysofweek     = array ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
		$this -> workweekstarts = 1;
		$this -> workweekends   = 6;
		$this -> workdaystarts  = 7;
		$this -> workdayends    = 20;
		$this -> weekDate = array();
		$this -> db_obj = new bocalendar();
	}
	var $public_functions = array(
			'quickAdd' => True,
			'getViewDay' => true
			);

	function normDec($value)
	{
		if ($value > 9)
			return $value;
		else
			return "0".$value;
	}

	function quickAdd () {
		$start = isset ($_REQUEST["start"]) ? $_REQUEST["start"] : NULL;
		$end = isset ($_REQUEST["end"]) ? $_REQUEST["end"] : NULL;
		$title = isset ($_REQUEST["title"]) ? $_REQUEST["title"] : NULL;
		$description = isset ($_REQUEST["desc"]) ? $_REQUEST["desc"] : NULL;

		if ($start == NULL || $end == NULL || $title == NULL)
			return "false;Empty field";
		if (!eregi("^[a-zA-Z_.0-9-]*",$title))
			return "false;Invalid char in description";
		if (!eregi("^[0-9]*",$start))
			return "false;Wrong formed text";
		if (!eregi("^[0-9]*",$end))
			return "false;Wrong formed text";

		return $this->db_obj->insertEvent($start, $end, $title, $description);
	}

	function saveEvent () {
		$start = isset ($_REQUEST["start"]) ? $_REQUEST["start"] : NULL;
		$end = isset ($_REQUEST["end"]) ? $_REQUEST["end"] : NULL;
		$title = isset ($_REQUEST["title"]) ? $_REQUEST["title"] : NULL;
		$description = isset ($_REQUEST["desc"]) ? $_REQUEST["desc"] : NULL;
		$location = isset ($_REQUEST["location"]) ? $_REQUEST["location"] : NULL;	

		if ($start == NULL || $end == NULL || $title == NULL)
			return "false;Empty field";
		if (!eregi("^[a-zA-Z_.0-9-]*",$title))
			return "false;Invalid char in description";
		if (!eregi("^[0-9]*",$start))
			return "false;Wrong formed text";
		if (!eregi("^[0-9]*",$end))
			return "false;Wrong formed text";

		return $this->db_obj->insertEvent($start, $end, $title, $description, $location);
	}



	function changeEvent()
	{
		$calId = isset ($_REQUEST["cal_id"]) ? $_REQUEST["cal_id"] : NULL;
		$field = isset ($_REQUEST["field"]) ? $_REQUEST["field"] : NULL;
		$value = isset ($_REQUEST["value"]) ? $_REQUEST["value"] : NULL;
		if ($calId == NULL || $field == NULL || $value == NULL)
			return false;
		if (!eregi("^[a-zA-Z_.]*",$field))
			return "<false>Wrong formed text</false>";
		if (!eregi("^[a-zA-Z_.0-9-]*",$value))
			return "<false>Wrong formed text</false>";
		if (!eregi("^[0-9]*",$calId))
			return "<false>Wrong formed text</false>";

		return $this->db_obj->changeEvent($calId, $field, $value);
	}

	function removeEvent () {
		$id = isset ($_REQUEST["id"]) ? $_REQUEST["id"] : NULL;
		if ($id == NULL)
			return "false;Internal Problem";

		return $this->db_obj->removeEventById($id);

	}

	function getViewDay () {
		$dayViewTime = isset ($_REQUEST["time"]) ?  strtotime(substr($_REQUEST["time"],0,4)."-".substr($_REQUEST["time"],6,2)."-".substr($_REQUEST["time"],4,2)) : strtotime(date('Y-m-d', time()));
		if (isset ($_REQUEST["uid"]))
			$this->db_obj->user_id = $_REQUEST["uid"];

		$retorno = "<today>".date('Ydm',$dayViewTime)."</today>";
		// Printing results in XML
		for($i = $this->workdaystarts; $i <= $this->workdayends; $i = $i + 0.5)
		{
			if($i == intval($i))
				$retorno.= "<workday><timeid>".$this->normDec(intval($i))."00</timeid><hour>".$this->normDec(intval($i)).":00</hour>";
			else
				$retorno.= "<workday><timeid>".$this->normDec(intval($i))."30</timeid><hour>".$this->normDec(intval($i)).":30</hour>";
		
		$retorno .= "</workday>";
		}	
		return $retorno;
	}
	function getEventsDay () {
		$dayTime = isset ($_REQUEST["time"]) ?  strtotime(substr($_REQUEST["time"],0,4)."-".substr($_REQUEST["time"],6,2)."-".substr($_REQUEST["time"],4,2)) : strtotime(date('Y-m-d', time()));
		if (isset ($_REQUEST["uid"]))
			$this->db_obj->user_id = $_REQUEST["uid"];
		if (isset ($_REQUEST["cat"]))
			$this->db_obj->cat_id = $_REQUEST["cat"];

		$fromBo = $this->db_obj->requestDayCal($dayTime);

		if (is_array($fromBo))
			foreach ($fromBo as $line){
				$retorno .= "<calevent>";
				$retorno .= "<id>".$line['cal_id']."</id>";
				$retorno .= "<title>".htmlspecialchars($line['title'])."</title>";
				$retorno .= "<description>".htmlspecialchars($line['description'])."</description>";
				$retorno .= "<edatetime>".($line['edatetime']*1000)."</edatetime>";
				$retorno .= "<datetime>".($line['datetime']*1000)."</datetime>";
				$retorno .= "</calevent>";
			}
		return $retorno;
	}

	function getViewWeek () {
		$dayViewTime = isset ($_REQUEST["time"]) ?  strtotime(substr($_REQUEST["time"],0,4)."-".substr($_REQUEST["time"],6,2)."-".substr($_REQUEST["time"],4,2)) : strtotime(date('Y-m-d', time()));
		$dayViewTime -= (date('N', $dayViewTime)%7)*86400;
		$retorno = "<today>".date('Ydm', $dayViewTime)."</today>";
		if (isset ($_REQUEST["uid"]))
			$this->db_obj->user_id = $_REQUEST["uid"];

		for($i = $this->workdaystarts; $i <= $this->workdayends; $i = $i + 0.5){
			if($i == intval($i))
				$retorno.= "<workday><timeid>".$this->normDec(intval($i))."00</timeid><hour>".$this->normDec(intval($i)).":00</hour>";
			else
				$retorno.= "<workday><timeid>".$this->normDec(intval($i))."30</timeid><hour>".$this->normDec(intval($i)).":30</hour>";
			$retorno .= "</workday>";
		}
		$currentWeekDay = date('w', $dayViewTime);

		for($i = $this->workweekstarts; $i <= $this->workweekends; $i++){
			$retorno.= "<workweek><dayid>".date("Ydm", $dayViewTime - (($currentWeekDay-$i)*60*60*24))."</dayid><dayofweek>".$this->daysofweek[$i]."</dayofweek></workweek>";
		}

		return $retorno;
	}
	function getEventsWeek () {
		$dayViewTime = isset ($_REQUEST["time"]) ?  strtotime(substr($_REQUEST["time"],0,4)."-".substr($_REQUEST["time"],6,2)."-".substr($_REQUEST["time"],4,2)) : strtotime(date('Y-m-d', time()));
		if (isset($_REQUEST["uid"]))
			$this->db_obj->user_id = $_REQUEST["uid"];
		if (isset ($_REQUEST["cat"]))
			$this->db_obj->cat_id = $_REQUEST["cat"];

		$dayViewTime -= (date('N', $dayViewTime)%7)*86400;
		$retorno = "<today>".date('Ydm', $dayViewTime)."</today>";
		if (isset ($_REQUEST["uid"]))
			$this->db_obj->user_id = $_REQUEST["uid"];


		$fromBo = $this->db_obj->requestWeekCal($dayViewTime);


		// Printing results in XML
		if (is_array($fromBo))
			foreach ($fromBo as $line) {
				if ($line['datetime'] > 0){
					$retorno .= "<calevent>";
					$retorno .= "<id>".$line['cal_id']."</id>";
					$retorno .= "<title>".htmlspecialchars($line['title'])."</title>";
					$retorno .= "<description>".htmlspecialchars($line['description'])."</description>";
					$retorno .= "<edatetime>".($line['edatetime']*1000)."</edatetime>";
					$retorno .= "<datetime>".($line['datetime']*1000)."</datetime>";
					$retorno .= "</calevent>";
				}
			}
		return $retorno;
	}


	function getDetails (){
		$eventId = isset ($_REQUEST["id"]) ? $_REQUEST["id"] : NULL;
		$fromBo = $this->db_obj->requestDetailsEvent($eventId);
		foreach ($fromBo[0] as $field => $line) {
			$buff .= "<".$field.">".$line."</".$field.">";
		}
		return $buff;
	}
	function getEventsMonth () {
		$monthViewTime = isset ($_REQUEST["time"]) ?  strtotime(substr($_REQUEST["time"],0,4)."-".substr($_REQUEST["time"],6,2)."-".substr($_REQUEST["time"],4,2)) : strtotime(date('Y-m-d', time()));
		$todayTime = strtotime(date('Y-m', $monthViewTime)."-01");
		if (isset($_REQUEST["uid"]))
			$this->db_obj->user_id = $_REQUEST["uid"];
		if (isset ($_REQUEST["cat"]))
			$this->db_obj->cat_id = $_REQUEST["cat"];

		$fromBo = $this->db_obj->requestMonthCal($todayTime);

		// Printing results in XML
		if (is_array($fromBo))
			foreach ($fromBo as $line) {
				if ($line['datetime'] > 0){
					$retorno .= "<calevent>";
					$retorno .= "<id>".$line['cal_id']."</id>";
					$retorno .= "<title>".htmlspecialchars($line['title'])."</title>";
					$retorno .= "<edatetime>".($line['edatetime']*1000)."</edatetime>";
					$retorno .= "<datetime>".($line['datetime']*1000)."</datetime>";
					$retorno .= "</calevent>";
				}
			}
		return $retorno;
	}
	
	function getViewMonth () {
		$monthViewTime = isset ($_REQUEST["time"]) ?  strtotime(substr($_REQUEST["time"],0,4)."-".substr($_REQUEST["time"],6,2)."-".substr($_REQUEST["time"],4,2)) : strtotime(date('Y-m-d', time()));
		if (isset ($_REQUEST["uid"]))
			$this->db_obj->user_id = $_REQUEST["uid"];

		$todayTime = strtotime(date('Y-m', $monthViewTime)."-01");
		$retorno = "<today>".date('Ydm', $monthViewTime)."</today>";

		for ($i=1;$i<=date('t',$monthViewTime);$i++){
			if (($i % 7) == 1)
				$retorno .= "<workWeek>";
			$retorno .= "<workday><id>".date('Y',$monthViewTime).$this->normDec($i).date('m',$monthViewTime)."0000</id></workday>";
			if (($i % 7) == 0)
				$retorno .= "</workWeek>";
		}

		if (($i % 7) <= 6 && ($i % 7) > 1)
			$retorno .= "</workWeek>";

		$currentWeekDay = date('w', $monthViewTime);

		for($i = ($this->workweekstarts+$currentWeekDay)-1; $i <= $this->workweekends+$currentWeekDay; $i++){
			// Dayid is year+month+dayofMonth (currentDay-(dayofWeek+$i))
			$retorno.= "<dayofweek><dayname>".$this->daysofweek[$i%7]."</dayname></dayofweek>";
		 }

		return $retorno;
	}
	function getViewYear () {
		$monthViewTime = isset ($_REQUEST["time"]) ?  strtotime(substr($_REQUEST["time"],0,4)."-".substr($_REQUEST["time"],6,2)."-".substr($_REQUEST["time"],4,2)) : strtotime(date('Y-m-d', time()));

		$todayTime = strtotime(date('Y-m', $monthViewTime)."-01");
		$retorno = "<today>".date('Ydm', $monthViewTime)."</today>";

		$fromBo = $this->db_obj->requestYearCal($todayTime);
		// Printing results in XML
		if (is_array($fromBo))
		foreach ($fromBo as $line) {
			if ($line['datetime'] > 0){
				$retorno .= "<calevent>";
				$retorno .= "<id>".$line['cal_id']."</id>";
				$retorno .= "<datetime>".($line['datetime']*1000)."</datetime>";
				$retorno .= "</calevent>";
			}
		}
		return $retorno;
	}


};

?>
